
Program MAX192;
Uses CRT;
var BA : Integer;
    Offset: Real;

procedure Init;
begin
   BA := $03F8;     { COM1 }
   Port[BA+3]:=$40; { Break, TXD=1, Betriebsspannung }
   Port[BA+4]:=$00; { DTR(Sclk) = 0, RTS(Din) = 0 }
   delay (100);
end;

function shift8 (Commando: Byte):Byte;
var Aus, Lesen, Bit, N: Byte;
  i : Integer;
begin
  Bit := 128;
  Lesen := 0;
  for n:=1 to 8 do begin
    if (Commando AND Bit) = Bit then Aus := 2 else Aus := 0;
    Port[BA+4]:=Aus;        { Din }
    Port[BA+4]:=Aus+1;      { Din + Sclk }
    if (Port[BA+6] AND 16)= 16 then Lesen := Lesen + Bit;
    Port[BA+4]:=Aus;       { Din }
    Bit := Bit div 2;
  end;
  Shift8 := Lesen;
  Port[BA+4]:=$00;         { Din=0, Sclk=0 }
  delay(2);
end;

function Messung (Steuerbyte: Byte): Real;
var Ausgabe: Byte;
    Wert: Integer;
begin
  Ausgabe := shift8(Steuerbyte);         {Start}
  repeat until (Port[BA+6] AND 32)= 32;  {SSTRB, fertig}
  Wert := 16 * shift8(0);                {Highbyte}
  Wert := Wert + shift8(0)/16;           {Lowbyte}
  if (Steuerbyte AND 8)=8 then Wert:=Wert-2048; {bipolar}
  Messung := Wert/1000;
end;

procedure Vierkanal;
ver n: Integer;
begin
  GotoXY (1,1);
  write ('Kanal     einfach    Differenz    bipolar');
  for n := 0 to 3 do begin;
    GotoXY (1,2+n); write (N*2);
    GotoXY (10,2+n);
    write (Messung(128+16*n+8+4+2):5:3,'V');  {UNI,SGL}
    GotoXY (20,2+n);
    write (Messung(128+16*n+8+0+2):5:3,'V');  {UNI,/DIF}
    GotoXY (30,2+n);
    write (Messung(128+16*n+0+0+2):5:3,'V');  {/BIP,/DIF}
  end;
end;

begin
  Init;
  repeat Vierkanal until Keypressed;
end.


